#############################################################################################
# PoD-Adverts																				#
# Version: 			v1.1 [Date: 06.11.2012]													#
# Written by:																				#
#					TheSpeedFreak (Steam)													#
#					SpeedFreak (Eventscripts Forum)											#
#																							#
# Special Thanks to:																		#
#					Mattie:				Eventscripts Plugin									#
#					SuperDave:			ColorFormat-Function								#
#					Ayuto & Freakyy:	Huge amount of color codes							#
#					Brainsucker:		Coding												#
#																							#
# Website: 			www.NextGenerationGaming.de												#
# Description: 		Mod to install adverts on your server.									#
# 					Colors and custom server variables included.							#
#############################################################################################

import es
import cmdlib
import random
import copy
import gamethread
import urllib2
import time
from time import strftime

#Globals
pathColors = es.getAddonPath("pod_adverts")+'/configs/colors.txt'
pathVars = es.getAddonPath("pod_adverts")+'/configs/customvars.txt'
pathAdverts = es.getAddonPath("pod_adverts")+'/configs/adverts.txt'
adNumber = -1
newVersion = 0
startTime = None

#Lists
advertList = []
conPlayerList = []

#Dicts
colorDict = {}
serverVarDict = {}
specialVarDict = {}
addonVarDict = {}
importedAddons = {}

#Info
info = es.AddonInfo() 
info.name     	= 'PoD-Adverts' 
info.basename 	= 'pod_adverts'
info.version  	= es.ServerVar('pod_adverts_version')
info.url      	= 'http://addons.eventscripts.com/addons/view/PoD-Adverts' 
info.description = 'Mod to install adverts on your server. Colors and variables included.'
info.author   	= 'Steam: TheSpeedFreak | Eventscripts Forum: SpeedFreak'

#Version
def checkVersion():
	global newVersion
	try:
		file = urllib2.urlopen('http://www.nextgenerationgaming.de/addons/pod_adverts/pod_adverts.txt')
		version = file.readline()
		file.close()
		if version != es.ServerVar('pod_adverts_version'): newVersion = 1
	except urllib2.URLError:
		es.dbgmsg(1,"[PoD-Adverts] Couldn't check for updates!")
		return

def load():
	global colorDict, advertList, newVersion
	es.set('pod_adverts_version', 'v1.1')
	es.makepublic('pod_adverts_version')
	es.set('pod_adverts_delay',30)
	es.set('pod_adverts_prefix','#green[#lightgreenServer#green] ')
	es.set('pod_adverts_round','')
	es.set('pod_adverts_mode',2)
	es.server.queuecmd('es_xmexec ../addons/eventscripts/pod_adverts/configs/config.cfg')
	colorDict = importColors(pathColors)
	advertList = importAdverts(pathAdverts)
	importVars(pathVars)
	addServerVar('pod_adverts_version','<$version>')
	addSpecialVar(lambda: strftime("%H:%M:%S"),'<$time>')
	addSpecialVar(timeGet,'<$timeleft>','numeric')
	#Broken: addServerVar('nextmap','<$nextmap>','error')
	addSpecialVar(lambda: es.getplayercount(),'<$playercount>','numeric')
	addSpecialVar(lambda: es.getplayercount()-len(conPlayerList),'<$playercount2>','numeric')
	addSpecialVar(lambda: len(conPlayerList),'<$connecting>','numeric')
	addSpecialVar(lambda: es.getplayercount(3),'<$counterterrorists>','numeric')
	addSpecialVar(lambda: es.getplayercount(2),'<$terrorists>','numeric')
	addSpecialVar(lambda: es.getplayercount(1),'<$spectators>','numeric')
	addSpecialVar(lambda: es.getmaxplayercount(),'<$maxslots>','numeric')
	addSpecialVar(lambda: es.getmaxplayercount()-es.getplayercount(),'<$freeslots>','numeric')
	addServerVar('mp_friendlyfire','<$ff>')
	addServerVar('sv_alltalk','<$alltalk>')
	addServerVar('sv_gravity','<$gravity>','numeric')
	addServerVar('sv_enablebunnyhopping','<$bunnyhop>')
	addServerVar('sv_enableboost','<$boost>')
	addServerVar('sv_cheats','<$cheats>')
	addServerVar('hostname','<$hostname>')
	cmdlib.registerServerCommand('!colors','pod_adverts/debugColors','Displays all color codes in chat.')
	if len(advertList) > 0: gamethread.delayedname(3,'advertsDelay',displayAdverts)
	for userid in es.getUseridList(): whisper(userid,'%s #greensuccessfully loaded!' % es.ServerVar('pod_adverts_version'))
	checkVersion()
	if newVersion: msg('#black[#LightSeaGreenPoD-Adverts#black] #redA new version is available!')

def unload():
	cmdlib.unregisterServerCommand('!colors')
	gamethread.cancelDelayed('advertsDelay')
	for userid in es.getUseridList(): whisper(userid,'%s #greensuccessfully unloaded!' % es.ServerVar('pod_adverts_version'))

def es_map_start(ev):
	timeStart()
	checkVersion()

def round_end(ev):
	if int(ev['reason']) == 15: timeStart()

def es_player_validated(ev):
	if ev['networkid'] not in conPlayerList: conPlayerList.append(ev['networkid'])

def player_spawn(ev):
	if ev['es_steamid'] in conPlayerList: conPlayerList.remove(ev['es_steamid'])

def player_disconnect(ev):
	if ev['networkid'] in conPlayerList: conPlayerList.remove(ev['networkid'])

def round_start(ev):
	if es.ServerVar('pod_adverts_round') != '' or es.ServerVar('pod_adverts_round') != "": editAdvert(str(es.ServerVar('pod_adverts_prefix'))+str(es.ServerVar('pod_adverts_round')))
	if newVersion: msg('#black[#LightSeaGreenPoD-Adverts#black] #redA new version is available!')

def timeStart():
	global startTime
	startTime = int(time.time())

def timeGet():
	if startTime == None:
		return '(Not calculated)'
	else:
		timelimit = (es.ServerVar('mp_timelimit')*60)
		running = int(time.time())-startTime
		timeleft = timelimit-running
		if timeleft <= 0:
			return '00:00'
		else:
			minutes,seconds = divmod(timeleft,60)
			return "%02d:%02d" % (minutes,seconds)

def displayAdverts(listOfAdverts=[]):
	global adNumber
	gamethread.cancelDelayed('advertsDelay')
	gamethread.delayedname(es.ServerVar('pod_adverts_delay'),'advertsDelay',displayAdverts)
	mode = es.ServerVar('pod_adverts_mode')
	if mode == 1:
		adNumber += 1
		if adNumber >= len(advertList): adNumber = 0
	elif mode == 2:
		adNumber = random.randint(0,len(advertList)-1)
	if listOfAdverts == []:
		listOfAdverts = copy.deepcopy(advertList)
		advert = str(advertList[adNumber])
	else:
		advert = listOfAdverts[random.randint(0,len(listOfAdverts)-1)]
	if advert.startswith('<!if>') and '<!then>' in advert:
		check,text = editAdvert(advert,1)
		if check:
			msg(es.ServerVar('pod_adverts_prefix')+text)
		else:
			if text != None:
				msg(es.ServerVar('pod_adverts_prefix')+text)
			else:
				if mode == 1:
					displayAdverts()
				else:
					listOfAdverts.remove(advert)
					if len(listOfAdverts) == 0: return
					displayAdverts(listOfAdverts)
	else:
		editAdvert(es.ServerVar('pod_adverts_prefix')+advert)

def editAdvert(advert,ifStatement=False):
	if '.is_loaded>' in advert:
		loop = advert.count('.is_loaded>')
		loadedAddons = []
		for loaded in es.addons.getAddonList():
			name = loaded.__name__.rsplit('.', 1)[0].replace('.', '/')
			loadedAddons.append(name)
		if loop == advert.count('<addon.'):
			for x in xrange(0,loop):
				loaded = 0
				addonName = advert[advert.find('<addon.')+7:advert.find('.is_loaded>')]
				if es.exists('script',addonName): loaded = 1
				if addonName in loadedAddons: loaded = 1
				advert = advert.replace('<addon.%s.is_loaded>' % addonName,str(loaded))
	if len(specialVarDict) > 0 and '<$' in advert:
		for outputname in specialVarDict:
			value = str(specialVarDict[outputname][0]())
			style = specialVarDict[outputname][1]
			if style == 'text' and value is '0': value = 'Off'
			if style == 'text' and value is '1': value = 'On'
			if style == 'numeric' and value == 'Off': value = '0'
			if style == 'numeric' and value == 'On': value = '1'
			advert = advert.replace(outputname,value)
	if len(serverVarDict) > 0 and '<$' in advert:
		for outputname in serverVarDict:
			value = str(es.ServerVar(serverVarDict[outputname][0]))
			style = serverVarDict[outputname][1]
			if style == 'text' and value is '0': value = 'Off'
			if style == 'text' and value is '1': value = 'On'
			if style == 'numeric' and value == 'Off': value = '0'
			if style == 'numeric' and value == 'On': value = '1'
			if style == 'error' and (value == 'Off' or value == '0'): value = 'Unknown'
			advert = advert.replace(outputname,value)
	if len(addonVarDict) > 0 and '<$' in advert:
		for outputname in addonVarDict:
			if outputname not in importedAddons:
				try:
					plugin = es.import_addon(addonVarDict[outputname][0])
					importedAddons[outputname] = plugin
				except:
					es.dbgmsg(1,"[PoD-Adverts] Couldn't get variables from %s, because the addon is not loaded!" % addonVarDict[outputname][0])
			else:
				plugin = importedAddons[outputname]
			if addonVarDict[outputname][2] == '0':
				try:
					value = str(plugin.__dict__[addonVarDict[outputname][1]])
				except:
					es.dbgmsg(1,"[PoD-Adverts] Couldn't get variable %s from %s, because it doesn't exist!" % (str(addonVarDict[outputname][1]),addonVarDict[outputname][0]))
				else:
					style = addonVarDict[outputname][3]
					if style == 'text' and value is '0': value = 'Off'
					if style == 'text' and value is '1': value = 'On'
					if style == 'numeric' and value == 'Off': value = '0'
					if style == 'numeric' and value == 'On': value = '1'
					advert = advert.replace(outputname,value)
			elif addonVarDict[outputname][2] == '1':
				aInfo = es.addons.getAddonInfo(addonVarDict[outputname][0])
				name = 'Unknown'
				author = 'Unknown'
				version = 'Unknown'
				url = 'Unknown'
				if not aInfo is None:
					if aInfo.has_key('name') and addonVarDict[outputname][1] == 'name':
						name = aInfo['name']
						advert = advert.replace(outputname,name)
					if aInfo.has_key('author') and addonVarDict[outputname][1] == 'author':
						author = aInfo['author']
						advert = advert.replace(outputname,author)
					if aInfo.has_key('version') and addonVarDict[outputname][1] == 'version':
						version = aInfo['version']
						advert = advert.replace(outputname,version)
					if aInfo.has_key('url') and addonVarDict[outputname][1] == 'url':
						url = aInfo['url']
						advert = advert.replace(outputname,url)
	if ifStatement:
		statement,advertTrue,advertFalse = filterIfStatement(advert)
		try:
			if (eval(statement)): return True,advertTrue
		except:
			es.dbgmsg(0,"[PoD-Adverts] Couldn't check IF-Statement: !%s:" % statement)
		return False,advertFalse
	msg(advert)

def filterIfStatement(text):
	statement = text[6:text.find('<!then>')-1]
	statement = statement.replace('Off','0')
	statement = statement.replace('On','1')
	if '<!else>' in text:
		advertFalse = text[text.find('<!else>')+8:len(text)]
		advertTrue = text[text.find('<!then>')+8:text.find('<!else>')-1]
		return statement,advertTrue,advertFalse
	else:
		advertTrue = text[text.find('<!then>')+8:len(text)]
		return statement,advertTrue,None
	
def addServerVar(inputname,outputname,outputstyle='text'):
	serverVarDict[outputname] = [inputname,outputstyle]

def addSpecialVar(function,outputname,outputstyle='text'):
	specialVarDict[outputname] = [function,outputstyle]

def addAddonVar(addonname,inputname,outputname,info,outputstyle='text'):
	addonVarDict[outputname] = [addonname,inputname,info,outputstyle]

def importVars(filename):
	file = open(filename,'r')
	for line in file:
		line = line.replace('\n','')
		if line.startswith('server|'):
			line = line.split('|',-1)
			if len(line) == 4: addServerVar(str(line[1]),'<$'+str(line[2])+'>',str(line[3]))
		elif line.startswith('addon|'):
			line = line.split('|',-1)
			if len(line) == 5: addAddonVar(str(line[1]),str(line[2]),'<$'+str(line[3])+'>','0',str(line[4]))
		elif line.startswith('addoninfo|'):
			line = line.split('|',-1)
			if len(line) == 4: addAddonVar(str(line[1]),str(line[2]),'<$'+str(line[3])+'>','1')
	file.close()

def importColors(filename):
	tempDict = {}
	file = open(filename,'r')
	for line in file:
		if line.startswith('#'):
			color,RGB = line.split('=',1)
			color = color.strip()
			RGB = RGB.strip()
			RGB = RGB.split(',')
			tempDict[color] = RGB
	file.close()
	return tempDict

def importAdverts(filename):
	tempList = []
	file = open(filename,'r')
	for line in file:
		if not line.startswith('//') and not line.startswith('\n'): tempList.append(line)
	file.close()
	return tempList

def debugColors():
	file = open(pathColors,'r')
	groupname = "No Group"
	for line in file:
		if line.startswith('<') and line.endswith('>\n'):
			groupname = line[1:len(line)-2]
			es.msg('----------------------------------------\n'+groupname+'\n----------------------------------------\n')
		if line.startswith('#'):
			color,RGB = line.split('=',1)
			color = color.strip()
			RGB = RGB.strip()
			RGB = RGB.split(',')
			msg('%s%s' % (color,color[1:len(color)]))
	file.close()

def formatColor(R,G,B):
	return '\x07%02X%02X%02X' % (R,G,B)

def msg(message):
	if '#' in message:
		for color in colorDict:
			R,G,B = colorDict[color]
			message = message.replace(color,formatColor(int(R),int(G),int(B)))
	es.msg(message)
	
def whisper(userid,msg):
	es.tell(userid,'#multi','\x07000000[\x0720B2AAPoD-Adverts\x07000000] \x0720B2AA%s' % str(msg))